'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _component = require('./component');

var _component2 = _interopRequireDefault(_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file 交通路况图层组件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author kyle(hinikai@gmail.com)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var TrafficLayer = function (_Component) {
    _inherits(TrafficLayer, _Component);

    function TrafficLayer(args) {
        _classCallCheck(this, TrafficLayer);

        var _this = _possibleConstructorReturn(this, (TrafficLayer.__proto__ || Object.getPrototypeOf(TrafficLayer)).call(this, args));

        _this.state = {};
        return _this;
    }

    _createClass(TrafficLayer, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            this.initialize();
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.initialize();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var map = this.props.map;
            if (map && map.removeTileLayer && map.removeTileLayer instanceof Function && this.tileLayer) {
                map.removeTileLayer(this.tileLayer);
                this.tileLayer = null;
            }
        }
    }, {
        key: 'initialize',
        value: function initialize() {
            var map = this.props.map;
            var defaultTilesUrl = 'http://its.map.baidu.com:8002/traffic/TrafficTileService';
            var tilesUrl = this.props.tilesUrl ? this.props.tilesUrl : defaultTilesUrl;

            if (!map) {
                return;
            }

            if (!this.tileLayer) {
                this.tileLayer = new BMap.TileLayer({
                    isTransparentPng: true
                });
                var scaler = Math.round(window.devicePixelRatio || 1);
                scaler = Math.min(2, scaler);
                scaler = Math.max(1, scaler);
                this.tileLayer.getTilesUrl = function (tileCoord, zoom) {
                    var x = tileCoord.x;
                    var y = tileCoord.y;
                    var time = new Date().getTime();
                    return tilesUrl + '?level=' + zoom + '&x=' + x + '&y=' + y + '&time=' + time + '&v=081&scaler=' + scaler; // 根据当前坐标，选取合适的瓦片图
                };
            }
            map.addTileLayer(this.tileLayer);
        }
    }]);

    return TrafficLayer;
}(_component2.default);

exports.default = TrafficLayer;